import { Vec3 } from "Vec3";
import {world,system} from "@minecraft/server";
import {customRaid} from "./configs.js";
function CrDistance(a,b){
  const x=a.x-b.x;
  const y=a.y-b.y;
  const z=a.z-b.z;
  return Math.sqrt(x**2+y**2+z**2);
};
function CrUnitVector(v){
  const l=Math.sqrt(v.x**2+v.y**2+v.z**2);
  return {x:v.x/l,y:v.y/l,z:v.z/l};
};
var iwck={x:0,y:0,z:0};
system.runInterval(()=>{
  const entities=Array.from(world.getDimension("overworld").getEntities());
	for(const entity of entities){
	  const entityId=entity.typeId;
	  const hp=entity.getComponent('health');
		const ehc=(hp?.currentValue ?? 0);
		const ehd=(hp?.defaultValue ?? 0);
		const ehl=ehd-ehc;
		if(entityId!=="cr:iw" && entity.hasTag("cr:iwck")){
		  if(entityId!=="minecraft:player"){
	      const v={x:iwck.x*2.55,y:0.085,z:iwck.z*2.55};
	      entity.applyImpulse(v);
	    }
		  else{
	      entity.applyKnockback(iwck.x,iwck.z,2,1);
	    }
	    entity.removeTag("cr:iwck");
    }
	}
});
world.afterEvents.entityHurt.subscribe(lt=>{

  const source=(lt.damageSource?.damagingEntity ?? lt.damageSource?.damagingProjectile);

  const sourceId=source?.typeId;
  const shp=source?.getComponent("health");
  const shd=shp?.defaultValue;
  const shc=shp?.currentValue;
  const shl=shd-shc;
  const entity=lt.hurtEntity;
  const entityId=entity?.typeId;
  const ehp=entity?.getComponent("health");
  const ehd=ehp?.defaultValue;
  const ehc=ehp?.currentValue;
  const ehl=ehd-ehc;
  const dmgType=lt.damageSource?.cause;
  const dmg=lt.damage;
  //超级骷髅-攻击
	if(sourceId==="cr:raid_overlord" && entityId!=="cr:raid_overlord"){
    try{
      const skillId=source.getProperty("lt:skill_id");
	    const entityL=entity.location;
	    const sourceL=source.location;
	    const distance=CrDistance(entityL,sourceL);
	    if(dmgType==="selfDestruct" || dmgType==="projectile"){
  	    let multi,unitV,vX,vY,vZ,dmgExtra,dmgFixed,knockMulti,lsv;
  	    switch(skillId){
  	      case "diagonal_swing":
  	      case "diagonal_combo1":
  	      case "diagonal_combo2":
  	        entity.setOnFire(5);
  	        lsv=((source.getProperty("lt:buffed") ? 1 : 0)+(Math.floor(Math.random()*3)+6));
  	        shp.setCurrentValue(shc+lsv);
  	        dmgExtra=Math.floor(ehd*0.03);
  	        dmgFixed=dmgExtra+15;
  	        entity.applyDamage(dmgFixed,{cause:"entityAttack",damagingEntity:(source ?? null)});
  	        break;
  	      case "vertical_swing":
  	        entity.setOnFire(5);
  	        dmgExtra=Math.floor(ehd*0.02);
  	        dmgFixed=dmgExtra+20;
  	        entity.applyDamage(dmgFixed,{cause:"entityAttack",damagingEntity:(source ?? null)});
  	        entity.applyKnockback(0,0,0,0.63);
  	        if(entityId!=="minecraft:player"){
  	          entity.applyImpulse({x:0,y:0.51,z:0});
  	        }
  	        break;
	  	      case "knockup_finish":
  	        dmgExtra=Math.floor(ehd*0.05);
  	        dmgFixed=dmgExtra+20;
  	        entity.applyDamage(dmgFixed,{cause:"entityAttack",damagingEntity:(source ?? null)});
  	        entity.addEffect("weakness",2,{amplifier:5,showParticles:false});
  	        entity.addEffect("slowness",2,{amplifier:5,showParticles:false});
  	        unitV=CrUnitVector({x:sourceL.x-entityL.x,y:sourceL.y-entityL.y,z:sourceL.z-entityL.z});
  	        vX=-unitV.x*0.93;
  	        vY=0.80;
  	        vZ=-unitV.z*0.93;
  	        if(entityId!=="minecraft:player"){
  	          entity.applyImpulse({x:vX,y:vY,z:vZ});
  	        }
  	        else{
  	          entity.applyKnockback(vX,vZ,0.88,1.0);
  	        }
  	        break;
  	      case "knockup_jump_damage_finish":
  	        dmgExtra=Math.floor(ehd*0.03);
  	        dmgFixed=dmgExtra+10;
  	        entity.applyDamage(dmgFixed,{cause:"entityAttack",damagingEntity:(source ?? null)});
  	        entity.addEffect("weakness",2,{amplifier:5,showParticles:false});
  	        entity.addEffect("slowness",2,{amplifier:5,showParticles:false});
  	        if(entityId!=="minecraft:player"){
  	          entity.applyImpulse({x:0,y:-3.9,z:0});
  	        }
  	        else{
  	          entity.applyKnockback(0,0,0,-2.6);
  	        }
  	        break;
  	      default:
  	        break;
  	    }
  	  }
	  }catch(error){}finally{}
  }
});
world.afterEvents.dataDrivenEntityTrigger.subscribe(cr=>{
  const entity=cr.entity;
  const entityId=entity.typeId;
  const eventId=cr.eventId;
	if(entityId==="cr:iw" && eventId==="charge_damage"){
	  const iwck=entity.getVelocity();
  }
	if(entityId==="cr:iw" && eventId==="leap_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.12;
		  const vY=distance*unitV.y*0.14+0.09*distance;
		  const vZ=distance*unitV.z*0.12;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
	if(entityId==="cr:ironhorn_knight" && eventId==="ground_dodge_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.06;
		  const vY=distance*unitV.y*0.2+0.01*distance;
		  const vZ=distance*unitV.z*0.6;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
	if(entityId==="cr:iw"){
	  try{
  	  switch(eventId){
  	    case "stomp_finish":
  	    case "strike_finish":
  	    case "attack6_finish":
  	    case "leap_finish":
	        unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
	        vX=distance*unitV.x*0.35+unitV.x*0.21;
	        vY=distance*unitV.y*0.7;
	        vZ=distance*unitV.z*0.5+unitV.z*0.21;
	        vV={x:vX,y:vY,z:vZ};
	        entity.applyImpulse(vV);
  	      const heal=(1.5*(1-ehc/ehd)+0.5)*0.7;
  	      ehp.setCurrentValue(ehc+heal);
  	      break;
  	    default:
  	      break;
  	  }
	  }catch(error){}finally{}
	}
	if(entityId==="cr:raid_overlord"){
	  try{
	    const entityL=entity.location;
	    const targetL=entity.target.location;
	    const distance=CrDistance(entityL,targetL);
	    const diffX=targetL.x-entityL.x;
      const diffY=targetL.y-entityL.y;
      const length=Math.sqrt(diffX**2+diffY**2);
      const dirX=diffX/length;
      const dirY=diffY/length;
      const R0=entity.getRotation();
      const Rn={x:R0.x+dirX,y:R0.y+dirY};
	    let unitV,vX,vY,vZ,vV;
	    switch(eventId){
  	      case "knockup_jump_damage_finish":
  	        dmgExtra=Math.floor(ehd*0.03);
  	        dmgFixed=dmgExtra+10;
  	        entity.applyDamage(dmgFixed,{cause:"entityAttack",damagingEntity:(source ?? null)});
  	        entity.addEffect("weakness",2,{amplifier:5,showParticles:false});
  	        entity.addEffect("slowness",2,{amplifier:5,showParticles:false});
  	        if(entityId!=="minecraft:player"){
  	          entity.applyImpulse({x:0,y:-3.9,z:0});
  	        }
  	        else{
  	          entity.applyKnockback(0,0,0,-2.6);
  	        }
	      case "knockup_punch_damage":
	        unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
	        vX=distance*unitV.x*0.35+unitV.x*0.21;
	        vY=distance*unitV.y*0.19;
	        vZ=distance*unitV.z*0.35+unitV.z*0.21;
	        vV={x:vX,y:vY,z:vZ};
	        entity.applyImpulse(vV);
	        break;
	      case "knockup_jump_middle":
	        unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
	        vX=distance*unitV.x*0.25;
	        vY=distance*unitV.y*0.10;
	        vZ=distance*unitV.z*0.25;
	        vV={x:vX,y:vY,z:vZ};
	        entity.applyImpulse(vV);
	        break;
	      case "knockup_jump_damage_finish":
	      case "knockup_jump_finish":
	        entity.clearVelocity();
	        break;
	      default:
	        break;
	    }
	  }catch(error){}finally{}
  }
	if(entityId==="cr:shogun" && eventId==="charge_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.7;
		  const vY=distance*unitV.y*0.1+0.02*distance;
		  const vZ=distance*unitV.z*0.85;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
	if(entityId==="cr:dark_wave" && eventId==="charge_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.7;
		  const vY=distance*unitV.y*0.1+0.02*distance;
		  const vZ=distance*unitV.z*0.5;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
	if(entityId==="cr:raid_overlord" && eventId==="charged_slam_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.12;
		  const vY=distance*unitV.y*0.14+0.09*distance;
		  const vZ=distance*unitV.z*0.12;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
  	if(entityId==="cr:magnus" && eventId==="ragnaraku_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.12;
		  const vY=distance*unitV.y*0.14+0.09*distance;
		  const vZ=distance*unitV.z*0.12;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
	if(entityId==="cr:dark_hammerlord" && eventId==="jump_middle"){
	  try{
	    const entityL=entity.location;
      const targetL=entity.target.location;
      const distance=CrDistance(entityL,targetL);
  	  const unitV=CrUnitVector({x:targetL.x-entityL.x,y:targetL.y-entityL.y,z:targetL.z-entityL.z});
		  const vX=distance*unitV.x*0.12;
		  const vY=distance*unitV.y*0.14+0.09*distance;
		  const vZ=distance*unitV.z*0.12;
		  const vV={x:vX,y:vY,z:vZ};
		  entity.applyImpulse(vV);
		}catch(error){}finally{};
  }
   if (id === `cr:knockbackDamage`) {
        const [distance, horizontalForce, verticalForce, normalDamage, buffedDamage] = message.split(' ');

        // Convert the text to number
        const distanceNum = parseFloat(distance);
        const horizontalForceNum = parseFloat(horizontalForce);
        const verticalForceNum = parseFloat(verticalForce);
        const normalDamageNum = parseFloat(normalDamage);
        const buffedDamageNum = parseFloat(buffedDamage);

        if (!isNaN(distanceNum) && !isNaN(horizontalForceNum) && !isNaN(verticalForceNum) && !isNaN(normalDamageNum) && !isNaN(buffedDamageNum)) {
            const entityDir = Vec3(sourceEntity.getViewDirection().x * distanceNum, sourceEntity.getViewDirection().y * distanceNum, sourceEntity.getViewDirection().z * distanceNum);
            const entities = sourceEntity?.dimension.getEntities({ location: Vec3.add(entityDir, sourceEntity?.location), maxDistance: 3, excludeTypes: [sourceEntity.typeId], excludeFamilies: [`inanimate`, `despawn`] });
            entities.forEach((entity) => {
                if (sourceEntity?.matches({ families: [`magnus`] })) {
                    if (entity?.typeId !== `minecraft:player` && (entity?.matches({ excludeFamilies: [`magnus`] }) || entity?.matches({ families: [`little_orc`], excludeTags: [`riding`] }))) {
                        entity.applyImpulse({ x: sourceEntity?.getViewDirection().x * horizontalForceNum, y: verticalForceNum, z: sourceEntity?.getViewDirection().z * horizontalForceNum });
                        damage(entity, normalDamageNum, buffedDamageNum)
                    };
                } else {
                    if (entity?.typeId !== `minecraft:player`) {
                        entity.applyImpulse({ x: sourceEntity?.getViewDirection().x * horizontalForceNum, y: verticalForceNum, z: sourceEntity?.getViewDirection().z * horizontalForceNum });
                        damage(entity, normalDamageNum, buffedDamageNum)
                    };
                };
                if (entity?.typeId === `minecraft:player`) {
                    entity.applyKnockback(sourceEntity?.getViewDirection().x, sourceEntity?.getViewDirection().z, horizontalForceNum, verticalForceNum);
                    damage(entity, normalDamageNum, buffedDamageNum)
                }
            })
        }
    };
        function knockback() {
            const entities = sourceEntity.dimension.getEntities({ location: sourceEntity?.location, maxDistance: radius, excludeTypes: [sourceEntity.typeId], excludeFamilies: [`inanimate`, `despawn`] });
            entities.forEach((entity) => {
                if (entity?.typeId !== `minecraft:player`) {
                    entity.applyImpulse({ x: sourceEntity?.getViewDirection().x * horizontalForceNum, y: verticalForceNum, z: sourceEntity?.getViewDirection().z * horizontalForceNum });
                    damage(entity)
                };
                if (entity?.typeId === `minecraft:player`) {
                    entity.applyKnockback(sourceEntity?.getViewDirection().x, sourceEntity?.getViewDirection().z, horizontalForceNum, verticalForceNum);
                    damage(entity)
                }
            })
    };
	if(entityId==="cr:block_bounce" && eventId==="sensor"){
	  try{
	    const v1=entity.location;
	    const v2={x:v1.x,y:v1.y-1,z:v1.z};
	    const block=entity.dimension.getBlock(v2);
	    const blockId=block.typeId;
		  entity.runCommand(`replaceitem entity @e[type=cr:be,c=1] slot.weapon.mainhand 0 ${blockId}`);
		}catch(error){}finally{};
  }
});
world.afterEvents.dataDrivenEntityTrigger.subscribe(lt=>{
  const {entityId,eventId}=lt.entity;
  if(eventId==="minecraft:spawn_for_raid"){
    if(entityId==="minecraft:pillager"){
      customRaid.A.forEach(a=>{
        lt.entity.runCommand(`summon ${a} ~~~ ~~ minecraft:spawn_for_raid`);
  		});
    }
    if(entityId==="minecraft:vindicator"){
      customRaid.B.forEach(b=>{
        lt.entity.runCommand(`summon ${b} ~~~ ~~ minecraft:spawn_for_raid`);
  		});
    }
    if(entityId==="minecraft:ravager"){
      customRaid.C.forEach(c=>{
        lt.entity.runCommand(`summon ${c} ~~~ ~~ minecraft:spawn_for_raid`);
  		});
    }
    if(entityId==="minecraft:witch"){
      customRaid.D.forEach(d=>{
        lt.entity.runCommand(`summon ${d} ~~~ ~~ minecraft:spawn_for_raid`);
  		});
    }
    if(entityId==="minecraft:evocation_illager"){
      customRaid.E.forEach(e=>{
        lt.entity.runCommand(`summon ${e} ~~~ ~~ minecraft:spawn_for_raid`);
  		});
    }
  }
});