import { world, ItemStack } from '@minecraft/server';

// gneiss_door_lock
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('component:gneiss_door_unlock', {
        onPlayerInteract({ player, block }) {
            const { x, y, z } = block;
            const equipment = player.getComponent('equippable');

            if (equipment) {
                const selectedItem = equipment.getEquipment('Mainhand');
                if (selectedItem?.typeId === 'cr:glacier_shard') {
                    // Loop through the 5x5 area and remove the blocks
                    for (let offsetX = -2; offsetX <= 2; offsetX++) {
                        for (let offsetY = 0; offsetY <= 4; offsetY++) {
                            for (let offsetZ = -2; offsetZ <= 2; offsetZ++) {
                                player.runCommandAsync(`setblock ${x + offsetX} ${y + offsetY} ${z + offsetZ} air destroy`);
                            }
                        }
                    }

                    // Play sound for unlocking
                    player.playSound('sound.verdant_door_unlock', { pitch: 1, location: player.location, volume: 1 });

                    // Remove the key from the player's inventory if not in creative mode
                    if (player.getGameMode() !== 'creative') {
                        equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
                    }
                }
            }
        }
    });
});
