import {world,system} from "@minecraft/server";
export function CrDist(a,b){
  let x=a.x-b.x;
  let y=a.y-b.y;
  let z=a.z-b.z;
  return Math.sqrt(x**2+y**2+z**2);
};
export class CrEntityClass{
   constructor(extraInanimateTypes=[]){
     //默认无生命实体id列表
     this.defaultInanimateTypes=extraInanimateTypes.concat(["item","xp_orb","lightning_bolt","evocation_fang","tnt","arrow","thrown_trident"]);
};
export function CrInFront(entityL,targetL,vV,num){
  let vH={x:vV.x,y:0,z:vV.z};
  let vD=CrUnitV({x:targetL.x-entityL.x,y:0,z:targetL.z-entityL.z});
  return CrCos(vH,vD)>num;
};

//计算点位偏移
export function CrOffset(oldL,vD,r,s,t){
  let vg={x:0,y:1,z:0};
  let vd=CrUnitV(vD);
  let ve=CrUnitV(CrCrossProduct(vd,vg));
  let vf=CrUnitV(CrCrossProduct(vd,ve));
  let newL={
    x: oldL.x-ve.x*r-vf.x*s+vd.x*t,
    y: oldL.y-ve.y*r-vf.y*s+vd.y*t,
    z: oldL.z-ve.z*r-vf.z*s+vd.z*t
  };
  return {
    x: (isNaN(newL.x) ? oldL.x : newL.x),
    y: (isNaN(newL.y) ? oldL.y : newL.y),
    z: (isNaN(newL.z) ? oldL.z : newL.z)
  };
};
const ActorId="cr:iw";
const CrEntity=new CrEntityClass([ActorId]);
const ExcludeTypes=CrEntity.defaultInanimateTypes;
world.afterEvents.dataDrivenEntityTrigger.subscribe(cr=>{
  let {entity,eventId}=cr;
  if(entity.typeId===ActorId){
    let {dim,entityL,vH,inFront3}=CrEntity.getStates(entity);
    switch(eventId){
      case "stomp_finish":
      case "strike_finish":
        let newL=CrOffset(entityL,vH,0,0,4);
        let entsIn=dim.getEntities({excludeTypes:ExcludeTypes,excludeFamilies:["inanimate"],location:newL,minDistance:0,maxDistance:2});
        for(const entIn of entsIn){
          let entInL=entIn.location;
          if(CrDist(entityL,entInL)<0.8 || CrInFront(entityL,entInL,vH,0.7)){
            if(entIn.typeId!=="minecraft:player"){
              let typeFamilies=(entIn.getComponent("type_family")?.getTypeFamilies() || ["inanimate"]);
              if(typeFamilies.includes("shulker")){
                entInL.y+=0.1;
              }else if(typeFamilies.includes("bedrock_family")){
                entInL.y+=0.5
              }else if(typeFamilies.includes("warden")){
                entInL.y+=4
              }else if(typeFamilies.includes("irongolem")){
                entInL.y+=5
              }else{
                entInL.y+=6
              }
              entIn.teleport(entInL);
            }else{
              entIn.applyKnockback(0,0,0,4.5);
            }
);
          }
        }
        break;
      defaucr:
        break;
    }
	}
});